<?php
include_once '../xmlrpc.inc';
include_once '../xmlrpcs.inc';
include_once 'Mail/RFC822.php';
include_once 'Mail/mime.php';
include_once 'Mail.php';
include_once '../friendshare.php';

$sendInvitesSig = array( array ( $xmlrpcString, 
	$xmlrpcString, $xmlrpcString, $xmlrpcString, $xmlrpcArray, $xmlrpcString ) );
$doAccountsExistSig = array( array( $xmlrpcString, $xmlrpcArray ) );

$server = new xmlrpc_server(
	array(
		'doAccountsExist' =>
			array(
				'function' => 'doAccountsExist',
				'signature' => $doAccountsExistSig
			),
		'sendInvites' =>
			array(
				'function' => 'sendInvites',
				'signature' => $sendInvitesSig
			)
		)
);


		function
getAccountStatus( $a, $db ) {
	//-2, DB error
	//-1, bad e-mail address
	// 0, account does not exist
	// 1, account exists, 'friend'
	$config = $GLOBALS[ 'config' ];

	if ( !$db ) {
		return( -2 );
	}
	//check for valid e-mail RFC 822 address
	if ( !Mail_RFC822::isValidInetAddress( $a ) ) {
		return( -1 );
	}
	//check for address ending in the default realm
	if ( preg_match( "/@.*\.?" . $config[ 'root' ][ 'realm' ] . "$/i", $a )) {
		return( -1 );
	}

	if ( get_magic_quotes_gpc() ) {
		$a = stripslashes( $a );
	}
	$a = mysql_real_escape_string( $a );
	//check if account is in Friend DB
	$result = mysql_query( "SELECT pin, UNIX_TIMESTAMP( last_modified ) FROM friend where login = '$a'", $db );
	if ( !$result ) {
		error_log( 'Friend: Could not SELECT from friend DB: ' . mysql_error() );
		return( -2 );
	}
	//if account in friend DB, see if it's been activated yet
	switch ( mysql_num_rows( $result ) ) {
	case 0 :
		return( 0 );
	case 1 :
		return( 1 );
	default :
		error_log( "Friend: Too many rows found in friend DB for account $a." );
		return( -2 );
	} 

}

		function
doAccountsExist( $params ) {

	$config = $GLOBALS[ 'config' ];
	
	if ( !authorizeClient( $_SERVER[ 'SSL_CLIENT_S_DN_CN' ] ) ) {
		return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_notauthorized' ],
			$GLOBALS[ 'notauthorized' ] );
	}

	$n = $params->getNumParams();
	///the number and type of params will be calculated with an actual
	///function signature.  the follow two ifs will become superfluous
	$accounts = $params->getParam( 0 );
	if ( $accounts->arraysize() < 1 ) {
		return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_needmoredata' ],
			$GLOBALS[ 'needmoredata' ] );
	}
	if ( !extension_loaded( 'mysql' ) ) {
   		if ( !dl( 'mysql.so' ) ) {    
			error_log( 'Friend: Mysql extension not loaded.  Could not respond to XML-RPC request.' );
			return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_dberr' ],
				$GLOBALS[ 'dberr' ] );
		}    
	}
	$db = mysql_connect( $config[ 'root' ][ 'dbhost' ],
		$config[ 'root' ][ 'dbuser' ], $config[ 'root' ][ 'dbpasswd' ] );
	if ( !$db ) {
		error_log( 'Friend: Could not connect to friend DB server (' . $config[ 'root' ][ 'dbhost' ] . ': ' . mysql_error() );
		return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_dberr' ],
			$GLOBALS[ 'dberr' ] );
	}
	if ( !mysql_select_db( 'friend', $db ) ) {
		error_log( 'Friend: Could not select friend DB: ' . mysql_error() );
		return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_dberr' ],
			$GLOBALS[ 'dberr' ] );
	}

	$response = array();
	for ( $i = 0; $i < $accounts->arraysize(); $i++ ) {
		$s = $accounts->arraymem( $i );
		$login = $s->scalarval();
		$gas = getAccountStatus( $login, $db );
		if ( $gas == -2 ) {
			return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_dberr' ],
				$GLOBALS[ 'dberr' ] );
		}
		$response[] = new xmlrpcval( $gas, 'int' );
	}
	mysql_close( $db );
	$ret = new xmlrpcval( $response, 'array' );
	
	return new xmlrpcresp( $ret );
}

		function
sendInvites( $params ) {
	$config = $GLOBALS[ 'config' ];
	$smarty = $GLOBALS[ 'smarty' ];

	$service_id = $_SERVER[ 'SSL_CLIENT_S_DN_CN' ];
	if ( !authorizeClient( $service_id ) ) {
		error_log( 'Friend: Unauthorized client ' . $service_id );
		return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_notauthorized' ],
			$GLOBALS[ 'notauthorized' ] );
	}

	$accounts = $params->getParam( 3 );
	
	if ( $accounts->arraysize() < 1 ) {
		return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_needmoredata' ],
			$GLOBALS[ 'needmoredata' ] );
	}
	
	if ( $accounts->arraysize() > $config[ 'root' ][ 'maxinvites'] ) {
		return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_toomuchdata' ],
			$GLOBALS[ 'toomuchdata' ] );
	}
	
	$response = array();
	$sent = 0;
	$from = $params->getParam( 0 )->scalarval();
	//make sure this is a valid e-mail address
	if ( !preg_match( "/@.*\.?" . $config[ 'root' ][ 'realm' ] . "$/i",
		$from )) {
		return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_badcontact' ],
			$GLOBALS[ 'badcontact' ] );
	}
	///make sure this is a validly constructed URL
	$referrer = $params->getParam( 1 )->scalarval();
	if ( !preg_match( "/^https?:\/\//", $referrer ) ) {
		/// Referrer must begin with http:// or https
	}	

	$invitemsg = $params->getParam( 2 )->scalarval();

	$invitor = $params->getParam( 4 )->scalarval();

	if ( !extension_loaded( 'mysql' ) ) {
   		if ( !dl( 'mysql.so' ) ) {    
			error_log( 'Friend: Mysql extension not loaded.  Could not respond to XML-RPC request.' );
			return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_dberr' ],
				$GLOBALS[ 'dberr' ] );
			exit( 0 );        
		}    
	}
	$db = mysql_connect( $config[ 'root' ][ 'dbhost' ],
		$config[ 'root' ][ 'dbuser' ], $config[ 'root' ][ 'dbpasswd' ] );

	if ( !$db ) {
		error_log( 'Friend: Could not connect to friend DB server: ' . mysql_error() );
		return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_dberr' ],
			$GLOBALS[ 'dberr' ] );
	}
	if ( !mysql_select_db( "friend", $db ) ) {
		error_log( 'Friend: Could not select friend DB: ' . mysql_error() );
		return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_dberr' ],
			$GLOBALS[ 'dberr' ] );
	}
	
	for ( $i = 0; $i < $accounts->arraysize(); $i++ ) {
		$s = $accounts->arraymem( $i );
		if ( $s->kindOf() != 'scalar' ) {
			return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_baddatatype'],
				$GLOBALS[ 'baddatatype' ] );
		}
		$addr = $s->scalarval();

		switch( getFriendStatus( $addr, $db ) ) {
		case -2:	//DB Error
			return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_dberr' ],
				$GLOBALS[ 'dberr' ] );
		case -1:	//Bad e-mail address
			//Put -1 in response array, continue processing other requests.
			$response[] = new xmlrpcval( -1, 'int' );
			///I believe this is right...
			continue( 2 );
			break;
		case 0:		//Account does not exist
			$pin = generateNewPin();
			$sql = "INSERT INTO friend ( login, referrer, service_contact, invitor, last_modified, pin, service_id ) VALUES ( '$addr', '$referrer', '$from', '$invitor', NOW(), '$pin', '$service_id' );";
			if ( !mysql_query( $sql, $db ) ) {
				error_log( 'Friend: Could not INSERT INTO friend DB: ' . mysql_error());
				return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_dberr' ], $GLOBALS[ 'dberr' ] );
			}
			break;
		case 1:		//Account exists
		case 2:		//Account exists (and password reset was requested)
			$pin = "";
			break;
		case 3:		//Account exists, PIN still good, password not set.
			//retrieve PIN from DB.
			$result = mysql_query( "SELECT pin FROM friend WHERE login = '$addr'", $db );
			if ( !$result ) {
				error_log( 'Friend: Could not SELECT from friend DB: ' . mysql_error() );
				return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_dberr' ], $GLOBALS[ 'dberr' ] );
			}
			$row = mysql_fetch_array( $result, MYSQL_NUM );
			$pin = $row[ 0 ];
			//Do NOT update DB.
			break;
		case 4:		//Account exists, PIN expired, password not set.
			$pin = generateNewPin();
			$sql = "UPDATE friend SET pin='$pin', last_modified=NOW(), referrer='$referrer', service_contact='$from', invitor='$invitor', service_id='$service_id' WHERE login='$addr'";
			if ( !mysql_query( $sql, $db ) ) {
				error_log( 'Friend: Could not UPDATE friend DB: ' . mysql_error() );
				return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_dberr' ], $GLOBALS[ 'dberr' ] );
			}
			break;
		default:
			error_log( 'Friend: function returned an undocumented response!' );
			return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_dberr' ],
				$GLOBALS[ 'dberr' ] );
		}

		/*
		$pinlife = $config[ 'root' ][ 'pinlife' ];
		$result = mysql_query( "SELECT pin, UNIX_TIMESTAMP( last_modified) FROM friend WHERE login = '$addr'", $db );
		if ( !$result ) {
			error_log( 'Friend: Could not SELECT from friend DB: ' . mysql_error() );
			return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_dberr' ],
				$GLOBALS[ 'dberr' ] );
		}
	
		switch( mysql_num_rows( $result) ) {
		case 0:
		
			// The account does not exist.  Make a new entry in DB before
			// sending invitation.
			$pin = generateNewPin();
			/// XXX need to make sure we're not inserting an already existing 
			/// pin!
			$sql = "INSERT INTO friend ( login, referrer, service_contact, invitor, last_modified, pin, service_id ) VALUES ( '$addr', '$referrer', '$from', '$invitor', NOW(), '$pin', '$service_id' );";
			if ( !mysql_query( $sql, $db ) ) {
				error_log( 'Friend: Could not INSERT INTO friend DB: ' . mysql_error());
				return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_dberr' ], $GLOBALS[ 'dberr' ] );
			}
			
			break;
		case 1:
		
			// If the pin is NULL, then this person has account is already set
			$pin = "";
			$row = mysql_fetch_array( $result, MYSQL_NUM );
			if ( $row[ 0 ] && $row[ 1 ] + $pinlife < time() ) {
				$pin = generateNewPin();
				
				$sql = "UPDATE friend SET pin='$pin', last_modified=NOW(), referrer='$referrer', service_contact='$from', invitor='$invitor', service_id='$service_id' WHERE login='$addr'";
				
				if ( !mysql_query( $sql, $db ) ) {
					error_log( 'Friend: Could not UPDATE friend DB: ' . mysql_error() );
					return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_dberr' ], $GLOBALS[ 'dberr' ] );
				}
				
			}
			
			break;
		default:
			error_log( "Friend: Too many rows found in friend DB for account $addr." );
			return new xmlrpcresp( 0, $GLOBALS[ 'FRIENDERR_dberr' ],
				$GLOBALS[ 'dberr' ] );
			break;
		}
		*/
		

		$smarty->assign( 'pin', $pin );
		if ( $from == $config[ 'root' ][ 'invitecontact' ] ) {
			$smarty->assign( 'from', $config[ 'root' ][ 'invitecontactpretty' ] );
		} else {
			$smarty->assign( 'from', $from );
		}
		$smarty->assign( 'referrer', $referrer );
		$smarty->assign( 'message', $invitemsg );
		$smarty->assign( 'friendServer', $config[ 'root' ][ 'friendserver' ] );

		if ( $pin ) {
			$text = $smarty->fetch( 'message.tpl' );
	 		$html = $smarty->fetch( 'message_html.tpl' );	
		} else {
			//if $pin is not set, account already exists and we'll send
			//a different message since the user doesn't need to go through
			//the account creation process.
			$text = $smarty->fetch( 'message_account_exists.tpl' );
			$html = $smarty->fetch( 'message_account_exists_html.tpl' );
		}
		$crlf = "\r\n";
		$hdrs = array( 'From' => $from,
			'Reply-To' => $config[ 'root' ][ 'invitecontact' ],
			'Subject' => $config[ 'root' ][ 'invitesubject' ] );
		$mime = new Mail_mime( $crlf );
		$mime->setTXTBody( $text );
		$mime->setHTMLBody( $html );
		$body = $mime->get();
		$hdrs = $mime->headers( $hdrs );
		$mail =& Mail::factory( 'mail' );
		$mail->send( $addr, $hdrs, $body );

		$response[] = new xmlrpcval( 1, 'int' );

	}

	mysql_close( $db );
	$ret = new xmlrpcval( $response, 'array' );
	
	return new xmlrpcresp( $ret );
}

	function
authorizeClient( $cn ) {
	
	$config = $GLOBALS[ 'config' ];
	$allowed = $config[ 'root' ][ 'allow' ];
	if ( $allowed == $cn ) {
		return( true );
	}
	if ( in_array( $cn, $allowed ) ) {
		return( true );
	}
	return( false );
	
}


?>
