<?php

require_once 'xmlrpc.inc';
include_once( '../friendshare.php' );

$smarty = $GLOBALS[ 'smarty' ];

if ( !extension_loaded( 'curl' ) ) {
	if ( !dl( 'curl-no-global_cleanup.so' ) ) {
		error_log( 'Friend: curl.so not loaded!' );
		$smarty->assign( 'error', 'Error loading PHP library!' );
		$smarty->display( 'error.tpl' );
		exit( 0 );
	}
}

if ( $_SERVER[ 'REMOTE_REALM' ] != 'UMICH.EDU' ) {
	$smarty->assign( 'error', 'This feature is only available to users with a uniqname.' );
	$smarty->display( 'error.tpl' );
	exit( 0 );
}

$smarty->assign( 'login',  $_SERVER[ 'REMOTE_USER' ] );

switch( $_POST[ 'command' ] ) {

case 'Next':
	checkAccounts( $smarty );
	break;

case 'Invite':
	inviteUsers( $smarty );
	break;

case 'Edit':
	if ( $_POST[ 'accounts' ] ) $smarty->assign( 'accounts',
		$_POST[ 'accounts' ] );
	if ( $_POST[ 'referrer' ] ) $smarty->assign( 'referrer',
		$_POST[ 'referrer' ] );
	if ( $_POST[ 'message' ] ) $smarty->assign( 'message',
		$_POST[ 'message' ] );

default:
	if ( $_POST[ 'from' ] ) {
		$smarty->assign( 'from', $_POST[ 'from' ] );
	} else {
		$smarty->assign( 'from', strtolower( $_SERVER[ 'REMOTE_USER' ] . '@' . $_SERVER[ 'REMOTE_REALM' ] ) );
	}
	$smarty->display( 'inviteform.tpl' );
	break;
}


		function
inviteUsers( $smarty )
{
	$config = $GLOBALS[ 'config' ];

	if ( !$_POST[ 'valid' ] || !$_POST[ 'from' ] || !$_POST[ 'referrer' ] ) {
		$smarty->assign( 'error', 'Insufficient data.' );
		$smarty->display( 'error.tpl' );
		exit( 0 );	
	}
	$accounts = unserialize( base64_decode( $_POST[ 'valid' ] ) );
	if ( count( $accounts ) < 1 ) {
		$smarty->assign( 'error', 'No valid e-mail addresses available.' );
		$smarty->display( 'error.tpl' );
		exit( 0 );
	}
	$xmlaccounts = array();
	for ( $i = 0; $i < count( $accounts ); $i++ ) {
		$xmlaccounts[] = new xmlrpcval( $accounts[ $i ], 'string' );
	}
	
	$contact = new xmlrpcval( $_POST[ 'from' ], 'string' );
	$referrer = new xmlrpcval( $_POST[ 'referrer' ], 'string' );
	if ( $_POST[ 'message' ] ) {
		$invitemsg = new xmlrpcval( $_POST[ 'message' ], 'string' );
	} else {
	//	$invitemsg = new xmlrpcval(
	//	$smarty->fetch( 'defaultinvitemsg.tpl' ), 'string' );
		$invitemsg = new xmlrpcval( '', 'string' );
	}
	$invitor = new xmlrpcval( $_SERVER[ 'REMOTE_USER' ], 'string' );

	$params = array( $contact, $referrer, $invitemsg,
		new xmlrpcval( $xmlaccounts, 'array' ), $invitor );
	$msg = new xmlrpcmsg( 'sendInvites', $params );
	$cli = new xmlrpc_client( $config[ 'root' ][ 'xmlrpcpath' ],
	    $config[ 'root' ][ 'xmlrpcserver' ] );
	$cli->setDebug( 0 );
	$cli->setSSLVerifyPeer( 0 );
	$cli->setCertificate( $config[ 'root' ][ 'cert' ], '' );
	$resp = $cli->send( $msg, 0, 'https' );

	if ( !$resp ) {
		error_log( 'XML-RPC communication error: ' . $cli->errstr );
		$smarty->assign( 'error', 'Communication error.' );
		$smarty->display( 'error.tpl' );
		exit( 0 );	
	}
	if ( $resp->faultCode() ) {
		error_log( 'Friend: ' . $resp->faultString );
		$smarty->assign( 'error', 'There was an error talking to the Friend database.  Please refresh your browser or try again later.' );
		$smarty->display( 'error.tpl' );
		return;
	}

	$smarty->display( 'invitesuccess.tpl' );
}

		function
checkAccounts( $smarty )
{
	$config = $GLOBALS[ 'config' ]; 
	$problems = 0;
	$all = $_POST[ 'accounts' ];
	$accounts = preg_split( "/[\s,]+/", $all );
	foreach( $accounts as $value ) {
		$params[] = new xmlrpcval( $value, 'string' );
	}

		if ( count( $params ) < 1 ) {
			$problems++;
		} else {

	$data = array( new xmlrpcval( $params, 'array' ) );
	$msg = new xmlrpcmsg( 'doAccountsExist', $data );
	$cli = new xmlrpc_client( $config[ 'root' ][ 'xmlrpcpath' ],
	    $config[ 'root' ][ 'xmlrpcserver' ] );
	$cli->setDebug( 0 );
	$cli->setSSLVerifyPeer( 0 );
	$cli->setCertificate( $config[ 'root' ][ 'cert' ], '' );
	$resp = $cli->send( $msg, 0, 'https' );

	if ( !$resp ) {
		error_log( 'XML-RPC communication error: ' . $cli->errstr );
		$smarty->assign( 'error', 'Communication error.' );
		$smarty->display( 'error.tpl' );
		exit( 0 );
	}
	if ( $resp->faultCode() ) {
		error_log( 'Friend: ' . $resp->faultString() );
		$smarty->assign( 'error', 'There was an error talking to the Friend database.  Please refresh your browser or try again later.' );
		///this is a dead-end and shouldn't be.
		$smarty->display( 'error.tpl' );
		exit( 0 );
	}

	$val = $resp->value();
	//Sanity check.  Make sure we have the same number of items in the response
	//array as the one we sent out.
	if ( $val->arraysize() != count( $params ) ) {
		error_log( 'Friend server sent an array of size ' . $val->arraysize() 
			. '. Was expecting size ' . count( $params ) );
		$smarty->assign( 'error', 'Response array wrong size!' );
		$smarty->display( 'error.tpl' );
		exit( 0 );
	}
	$invalid = array();
	$valid = array();

	for ( $i = 0; $i < count( $params ); $i++ ) {
		$r = $val->arraymem( $i );
		switch( $r->scalarval() ) {
		case -1:
			$problems++;
			$invalid[] = $params[ $i ]->scalarval();
			break;
		case 0:
		case 1:
		case 2:
		case 3:
			//For the purposes of the mass invite, we don't care at this
			//point what the exact state of the account is, only that it is a
			//valid e-mail address
			$valid[] = $params[ $i ]->scalarval();
			break;
		default:
			error_log( 'Friend server sent undocumented response (' . 
				$r->scalarval() . ').' );
			$smarty->assign( 'error', 'Invalid response from Friend server.' );
			$smarty->display( 'error.tpl' );
			exit( 0 );
		}
	}

	if ( count( $valid ) < 1 ) {
		$problems++;
		$smarty->assign( 'valid_err', 'At least one valid e-mail address must be specified.' );
	}
	$smarty->assign( 'invalid', $invalid );
	$smarty->assign( 'valid', $valid );
	$smarty->assign( 'validSerial', base64_encode( serialize( $valid ) ) );
	$smarty->assign( 'accounts', $_POST[ 'accounts' ] );
	
		}

	if ( !$_POST[ 'from' ] ) {
		$problems++;
		$smarty->assign( 'from_err', 'A service contact must be specified.' );
	} else {
	////// use default realm configuration!!!!!!
		if ( !preg_match( "/@.*\.?" . $config[ 'root' ][ 'realm' ] . "$/i", $_POST[ 'from' ] ) ) {
			$smarty->assign( 'from_err', 'Service contact must be a ' . $config[ 'root' ][ 'realm' ] . ' e-mail address.' );
			$problems++;
		}
		$smarty->assign( 'from', $_POST[ 'from' ] );
	}
	if ( !$_POST[ 'referrer' ] ) {
		$problems++;
	} else {
		$url = $_POST[ 'referrer' ];
		if ( !preg_match( "/^https?:\/\//", $url ) ) {
			$problems++;
			$smarty->assign( 'referrer_err', 'Service URL must begin with http:// or https://' );
		}
		$smarty->assign( 'referrer', $_POST[ 'referrer' ] );
	}
	$smarty->assign( 'message', $_POST[ 'message'] );
	$smarty->assign( 'problems', $problems );
	$smarty->assign( 'pin', 'abc123' );
	$smarty->assign( 'friendServer', $config[ 'root' ][ 'friendserver' ] );
	
	$smarty->display( 'invitecheck.tpl' );
}



?>

